﻿Imports System.IO

Public Class Form1


    Private Sub StartXLSXButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartXLSXButton.Click
        SetupAndLaunchFile("test.xlsx")
    End Sub

    Private Sub StartXLSButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartXLSButton.Click
        SetupAndLaunchFile("test.xls")
    End Sub

    Private Sub StartTXTButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartTXTButton.Click
        SetupAndLaunchFile("test.txt")
    End Sub



    Private Sub SetupAndLaunchFile(ByVal theFileName As String)
        'Clear old FileSystemWatchers
        Dim aDeadFSWs As New List(Of FileSystemWatcher)
        For Each aFSW As FileSystemWatcher In mFSWList.Keys
            If aFSW.Filter = theFileName Then
                aFSW.EnableRaisingEvents = False

                aDeadFSWs.Add(aFSW)
            End If
        Next

        For Each aFSW As FileSystemWatcher In aDeadFSWs
            mFSWList.Remove(aFSW)
            aFSW.Dispose()
        Next



        'Launch the XLSX file
        Process.Start(Path.Combine(Application.StartupPath, theFileName))

        'Generate New FileSystemWatchers
        For Each aNotifyFilterType As NotifyFilters In [Enum].GetValues(GetType(NotifyFilters))
            GenerateFSW(aNotifyFilterType, theFileName)
        Next

        
    End Sub

    Private mFSWList As New Dictionary(Of FileSystemWatcher, NotifyFilters)
    Private Sub GenerateFSW(ByVal theNotifyFilter As NotifyFilters, ByVal theFileName As String)
        Dim aNewFSW As New FileSystemWatcher(Application.StartupPath, theFileName)

        aNewFSW.NotifyFilter = theNotifyFilter

        AddHandler aNewFSW.Changed, AddressOf FSW_Changed

        aNewFSW.EnableRaisingEvents = True

        mFSWList.Add(aNewFSW, theNotifyFilter)

    End Sub

    Private Sub FSW_Changed(ByVal sender As Object, ByVal e As FileSystemEventArgs)
        Dim aSenderFSW As FileSystemWatcher = CType(sender, FileSystemWatcher)
        Dim aFSWNotificationName As String = [Enum].GetName(GetType(NotifyFilters), mFSWList(aSenderFSW))
        AddNotificationItem(aSenderFSW.Filter, aFSWNotificationName, IsUserSave(Path.Combine(Application.StartupPath, aSenderFSW.Filter)))
    End Sub

    Private Function IsUserSave(ByVal theFileName As String)
        Dim aFileAttributes As New FileInfo(theFileName)
        If Math.Abs(DateTime.Now.Subtract(aFileAttributes.LastWriteTime).Duration.TotalMilliseconds) < 1000 Then
            Return True
        Else
            Return False
        End If
    End Function


    Private Delegate Sub AddNotificationMethod(ByVal theFileName As String, ByVal theNotificationName As String, ByVal theSaveWasInitiatedByTheUser As String)
    Private Sub AddNotificationItem(ByVal theFileName As String, ByVal theNotificationName As String, ByVal theSaveWasInitiatedByTheUser As String)
        If NotificationEventListView.InvokeRequired Then
            NotificationEventListView.Invoke(New AddNotificationMethod(AddressOf AddNotificationItem), theFileName, theNotificationName, theSaveWasInitiatedByTheUser)
        Else
            Dim aNewListViewItem As New ListViewItem(New String() {Date.Now.ToLongTimeString(), theFileName, theNotificationName, theSaveWasInitiatedByTheUser.ToString()})
            NotificationEventListView.Items.Insert(0, aNewListViewItem)
        End If

    End Sub



End Class
